<template>
  <keep-alive>
    <div>
      <div style="position: relative; width: max-content">
        <img
          v-if="src"
          :src="src"
          alt="Avatar"
          class="avatar image"
          :style="{ height: size, width: size }"
        />
        <img
          v-else
          src="../assets/images/no-image.jpg"
          class="avatar no-image"
          :style="{ height: size, width: size }"
        />
        <LoadsSpinner style="position: absolute; top: calc(50% - 10px); left: calc(50% - 10px)" v-if="uploading || loading" small/>
      </div>
      <div v-if="button" :style="{ width: size }">
        <label class="button" for="single">
          <span v-if="!uploading && !loading" style="margin-bottom: 0;text-transform: none">{{ src.length ? "Изменить" : "Загрузить" }}</span>
          <LoadsSpinner v-if="uploading || loading" small/>
        </label>
        <input
          hidden
          type="file"
          id="single"
          accept="image/*"
          @change="uploadAvatar"
          :disabled="uploading"
        />
      </div>
    </div>
  </keep-alive>
</template>

<script>
import {onMounted, ref, toRefs, watch, computed} from "vue"
import { supabase } from "../supabase"
import LoadsSpinner from "./Loads-spinner.vue";
import {useStore} from "vuex";

export default {
  name: "Avatar",
  components: {LoadsSpinner},
  props: {
    path: String,
    button: {
      default: true
    }
  },
  emits: ["upload", "update:path"],
  setup(prop, { emit }) {
    const store = useStore()
    let profile = computed(function () {
      return store.state.profile
    });

    const { path } = toRefs(prop)
    const size = ref("10em")
    const uploading = ref(false)
    const src = ref("")
    const avatar_url = ref("")
    const files = ref()
    const loading = ref(false)

    const downloadImage = async () => {
      try {
        loading.value = true
        const { data, error } = await supabase.storage
          .from("avatars")
          .download(path.value ? path.value : avatar_url.value)
        if (error) throw error
        src.value = URL.createObjectURL(data)
      } catch (error) {
        console.error("Error downloading image: ", error.message)
      } finally {
        loading.value = false
      }
    }

    const uploadAvatar = async (evt) => {
      files.value = evt.target.files
      try {
        uploading.value = true
        if (!files.value || files.value.length === 0) {
          throw new Error("You must select an image to upload.")
        }

        const file = files.value[0]
        const fileExt = file.name.split(".").pop()
        const fileName = `${Math.random()}.${fileExt}`
        const filePath = `${fileName}`

        let { error: uploadError } = await supabase.storage
          .from("avatars")
          .upload(filePath, file)

        if (uploadError) throw uploadError
        emit("update:path", filePath)
        emit("upload")
      } catch (error) {
        alert(error.message)
      } finally {
        uploading.value = false
      }
    }

    watch(path, () => {
      if (path.value) downloadImage()
    })
    onMounted(() => {
      if (profile.avatar_url) {
        avatar_url.value = profile.avatar_url
        downloadImage()
      }
    })

    return {
      size,
      uploading,
      src,
      files,
      loading,

      uploadAvatar,
    }
  },
}
</script>
<style lang="scss" scoped>
img {
  border-radius: 50%;
  overflow: hidden;
}
.avatar.no-image {
  border-radius: 50%;
  overflow: hidden;
}
</style>
